# Grafana

TMC SM does not ship grafana, But you can install grafana by yourself and deploy our ready-made dashboards for 
visualizing/monitoring various metrics from TMC services.

First download this directory to your local machine. Then execute the below commands from a console within the grafana dir.

**NOTES:**
- This installation assumes that you want to install grafana in tmc-local namespace. If you want to change it, you will
  have to provide the desired namespace in `helm install` command and also update the namespace in `kustomization.yaml` file.
- If you install grafana using helm chart command specified below. The installation will use opensource grafana and
  a side-car image. You can modify those paths in values.yaml if you want to serve these from a custom registry.
- The `datasources.yaml` is pointing to prometheus at `http://prometheus-server-tmc-local-monitoring-tmc-local.tmc-local:9090`
  if that's not the case, make sure you update this with prometheus address.

## Installing a new grafana instance in your kubernetes cluster.
1. Install the grafana helm-chart
```bash
helm repo add grafana https://grafana.github.io/helm-charts
helm repo update

helm install grafana grafana/grafana -f values.yaml -n tmc-local

# obtain the password to login to grafana UI (username is `admin`)
kubectl get secret --namespace tmc-local grafana -o jsonpath="{.data.admin-password}" | base64 --decode ; echo
```

2. Loading charts into grafana.
```bash
# from within the grafana directory execute.
kubectl kustomize | kubectl apply -f -
```

3. Clean up
```bash
kubectl kustomize | k delete -f -

helm uninstall grafana -n tmc-local
```

## Loading charts manually in an existing grafana installation.
1. Download the grafana dir on your local
2. First you will need to create a datasource named "TMC-Prometheus" from grafana UI. 
   - Goto "Gear" icon on the left panel > "Data Sources" under "Data Sources" tab click "Add new data source".
   - Select promethues and in the name field enter "TMC-Prometheus".
   - In the URL field enter the internal url for prometheus as `http://prometheus-server-monitoring-tmc-local.tmc-local:9090`
   - Click "Save & Test" at the bottom and that is it.
3. Import the dashboards manually
   - Form left navigation menu select Dashboards > Browse > New > Import
   - Click "Upload Dashboard JSON file" and select the .json files in `dashboards` directory.
   - Enter a name(or you can use the defaults). Select "TMC-Prometheus" as data source from the last dropdown menu
   - Repeat the step 2 for each json file in `dashboards` dir and that's it.

